VERSION 5.00
Begin VB.Form LogWindow 
   Caption         =   "Log of last actions"
   ClientHeight    =   4155
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   13515
   Icon            =   "LogWindow.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   4155
   ScaleWidth      =   13515
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer timerLog1 
      Left            =   375
      Top             =   300
   End
   Begin VB.TextBox logText 
      BorderStyle     =   0  'None
      Height          =   4110
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   0
      Width           =   13470
   End
End
Attribute VB_Name = "LogWindow"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit

Private Const maxLogLines As Integer = 299
Private Const LogTimerDuration As Integer = 500  ' mettre 0 pour fonctionner sans timer
Private Const MAX_INT_LOG As Integer = 32760
Private formActivated As Boolean
Private curPtr As Integer
Private curPtrOnTimer As Integer
Private boInTimer As Boolean
Private boLogging As Boolean
Private logWindowText(maxLogLines) As String
Private fullText As String

Private logWindowWidth0 As Single, logWindowHeight0 As Single

Private logTextWindowWidth0 As Single, logTextWindowHeight0 As Single
Private logTextDeltaWidth As Single, logTextDeltaHeight As Single

Public Sub ClearLogScreen()
clearUpLog
displayLogText
End Sub

Public Sub AddLogLine(logString As String)
boLogging = True
DoEvents
' Il faut se proteger de l'appel a AddLogLine() pendant qu'on
' est en train d'afficher sous timer
Do While boInTimer
  DoEvents
Loop
curPtr = (curPtr + 1) Mod (maxLogLines + 1)
logWindowText(curPtr) = logString
setLogText
If (LogTimerDuration <= 0) Then
   displayLogText
End If
boLogging = False
End Sub

Public Sub ExitLogWindow()
clearUpLog
Unload Me
End Sub

Private Sub setLogText()
Dim i As Integer, s As String
fullText = logWindowText(curPtr)
For i = 1 To maxLogLines
    s = logWindowText((curPtr + maxLogLines + 1 - i) Mod (maxLogLines + 1))
    If (s <> "") Then fullText = (s & vbCrLf & fullText)
Next i
fullText = fullText & vbCrLf
If (Len(fullText) > MAX_INT_LOG) Then fullText = Right(fullText, MAX_INT_LOG)
End Sub

Private Sub displayLogText()
Dim i As Long, j As Integer
' supprimer les caracteres binaires, en les remplacant par un signe special
boLogging = True

If Len(fullText) > 0 Then
  For i = 1 To Len(fullText)
    j = Asc(Mid(fullText, i, 1))
    If (j < 32 And j <> 10 And j <> 13) _
    Or (j > 126 And j < 160) _
    Or (j > 255) _
    Then
      Mid(fullText, i, 1) = Chr$(191) ' point d'interro a l'envers
    End If
  Next i
End If
logText.Text = fullText
logText.SelStart = Len(fullText)
Me.Refresh

boLogging = False
End Sub

'-------------------------------------------------
' Fonction de log d'un  array of bytes
Public Sub displayLogByteArray(header As String, _
  buf() As Byte, ind As Long, ByVal lgr As Long)
Dim i As Long, s As String

' vrifier que UpperBoubd(buf) <= ind + lgr - 1
If (LBound(buf) > ind) Or _
  (UBound(buf) < (ind + lgr - 1)) Then
  Exit Sub
End If

'Utilisation d'une routine commune pour dumper le Byte Array
's = "[" & header & "]=>" & vbCrLf & hexaDump(VarPtr(buf(ind)), lgr)
s = "[" & header & "]=>" & hexaDump(VarPtr(buf(ind)), lgr)
AddLogLine s
End Sub

Private Sub clearUpLog()
Dim i As Integer

boLogging = True

curPtr = 0
'fullText = "No log action available"
fullText = ""
For i = 0 To maxLogLines
  logWindowText(i) = ""
Next i
boLogging = False
End Sub

Private Sub Form_Activate()
Dim i As Long
If Not formActivated Then
  Me.Move 0, 0
  clearUpLog
  displayLogText
  logWindowWidth0 = Me.Width: logWindowHeight0 = Me.Height
  logText.Move 0, 0
  logTextWindowWidth0 = logText.Width: logTextWindowHeight0 = logText.Height
  logTextDeltaWidth = logWindowWidth0 - logTextWindowWidth0
  logTextDeltaHeight = logWindowHeight0 - logTextWindowHeight0

'  AddLogLine "LogWindow: " & logWindowWidth0 & " , " & logWindowHeight0
'  AddLogLine "logTextWindow: " & logTextWindowWidth0 & " , " & logTextWindowHeight0 & _
'    " , " & logTextDeltaWidth & " , " & logTextDeltaHeight
End If
formActivated = True
End Sub

Private Sub Form_Load()
ClearLogScreen
boInTimer = False
boLogging = False
If (LogTimerDuration > 0) Then
  timerLog1.Interval = LogTimerDuration
  timerLog1.Enabled = True
  curPtrOnTimer = curPtr
End If
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
If UnloadMode = vbFormControlMenu Then
  Cancel = 1  ' pas de sortie par la croix ou le menu systeme
Else
  Cancel = 0
End If
End Sub

Private Sub Form_Resize()
If formActivated Then
  logText.Move 0, 0, Me.Width - logTextDeltaWidth, Me.Height - logTextDeltaHeight
End If
End Sub

Private Sub Form_Terminate()
formActivated = False
clearUpLog
End Sub

Private Sub Form_Unload(Cancel As Integer)
formActivated = False
clearUpLog
End Sub

Private Sub timerLog1_Timer()
If boLogging Then Exit Sub ' on est en train d'ecrire un record de log
If boInTimer Then Exit Sub ' on est deja en train de traiter
boInTimer = True
If (curPtrOnTimer <> curPtr) Then
  displayLogText
End If
curPtrOnTimer = curPtr
boInTimer = False
End Sub

