Attribute VB_Name = "PdfMgr"

Option Explicit

'**********************************
'**  Constant Definitions:

Public Const ProgNum As String = "550919"
Public Const ProgName As String = _
  "Patrice Goyer's portable document merger"

' Une constante publique ou un tableau public ne peut pas etre
' declare dans un module de classe, donc...

'
' Type et Enum definis dans PdfMgr.bas pour pouvoir les rendre publics
Public Type tPdfObjDesc
' numero de l'objet
  lObjNum As Long
' offset de l'objet dans son fichier (10 digits)
  lObjOffset As Long
' Generation number (5 digits)
  lObjGenNum As Long
' Mot-cle alphabetique : 'f' if free entry ; 'n' if normal entry
  sLiteralKeyword As String
' Type d'objet
  byObjType As tObjectType
' numero (0, 1 ou 2) du fichier contenant l'objet
  byFileIndex As Byte
' si l'objet est decrit dans un dictionary (cas le plus frequent)
' lObjectDict contient l'indice du 1er element dans le tableau
' Dictionary(), sinon (objet a valeur directe) lObjectDict vaut -1
  lObjectDict As Long
' indice de la 1ere ligne (de la forme 'N 0 obj') dans le tableau sObjLines()
  lBegLine  As Long
' indice de la derniere ligne (de la forme 'endobj' dans le tableau sObjLines()
  lLastLine As Long
' si l'object est la longueur d'un autre object
  lObjectValue As String ' "" si la valeur est dans un dictionay
' indice de l'en-tete de stream (de la forme 'stream') dans le tableau sObjLines()
'  lBegStreamLine  As Long ' pas besoin
' indice de la ligne de fin de stream (de la forme 'endstream') dans le tableau sObjLines()
'  lEndStreamLine As Long ' pas besoin
' Offset du stream dans son fichier
  lStreamOffset As Long ' -1 si le fichier n'a pas de stream
' longueur des donnees ('utiles') du stream
  lStreamLength As Long
' Numero et Generation number de l'objet qui contient la longueur du stream
  lNumObjectWithStreamLength As Long
  lGeNumObjectWithStreamLength As Long
End Type
'
' Note sur lStreamLength :
' Dans le fichier, un stream (binaire transparent) de longueur'
' lStreamLength est TOUJOURS cod de la manire suivante :
' stream CR LF
' ...
' Cr
' endstream
' o ... designe la suite d'octets de longueur lStreamLength incluse
' de maniere transparente (alors que le reste est textuel),
' CR = retour chariot (vbcR ou &H0D)
' LF = line feed (vbLF ou &H0A)
'
Public Enum tObjectType
  tObjFree = -1 ' objet non alloue
'  tObjUntyped ' objet non type
  tObjSize ' objet contenant la taille d'un autre
'  tObjRoot ' Racine du document (catalogue)
'  tObjPages ' Racine de l'arbre des pages
'  tObjInfo ' informations diverses
  tObjContentsWoStream ' page sans stream
  tObjContentsWiStream ' page avec stream
  tObjOther
End Enum


' Type decrivant un resultat d'analyse d'une table de Xref
Public Type tXrefResult
  lBase As Long ' numero de base de la table (num du 1er objet)
  lCount As Long ' nombre d'objets decrits
  lFirstTrailerStructureCell As Long
  lIndFirstTrailerLine As Long ' Indice de la 1ere ligne de trailer de cette XREF
  lIndLastTrailerLine As Long ' Indice de la 1ere ligne de trailer de cette XREF
  lSizeInTrailer As Long ' parametre /Size dans le trailer (nbre d'objets)
  lOffsetPrev As Long ' offset de la Xref precedente (ou -1)
  lRefRootCatalog As Long ' objet catalog (reference par l'entree /Root)
  lRefInfo As Long ' objet reference par l'entree /Info eventuelle
  lRefEncrypt As Long ' objet reference par l'entree /Encrypt eventuelle
  sIdValue As String ' valeur de l'ID du document (de la forme [<...><...>])
  boResult As Boolean ' resultat de l'operation
End Type

' Type decrivant un resultat d'analyse des objets d'un fichier d'entree
Public Type tObjP2Result
  boResult As Boolean ' resultat de l'operation
End Type


' Type defini dans PdfMgr.bas pour pouvoir le rendre public
Public Type tPdfDictionaryDesc ' Structure d'un dictionnaire (au sens PDF)
  lNextDictElement As Long ' indice du descripteur suivant
  sDictKey As String ' cle (exemples :  /Size  /Root /Info etc.)
  boValueIsSubDict As Boolean ' True si la valeur est un sous-dictionnaire
  sDictValue As String ' Valeur si boValueIsSubDict est "False" ("" sinon)
  lSubDictFirstElement As Long ' -1 ou indice du 1er descripteur du sous-dictionnaire
End Type

' Type servant a memoriser les caracteristiques d'un ulterieur calcul
' de longueur de stream dans le cas ou cette longueur est contenue
' dans un autre objet (longueur indirecte)
Public Type tObjIndirectLength
  lObjNum As Long
  lFormerObjNum As Long
  lObjLenNum As Long
  lObjLenFormerNum As Long
  lObjGenNum As Long
  iObjFile As Integer
End Type

