Attribute VB_Name = "WindowsAPI"

Option Explicit

'**********************************
'**  Constant Definitions:

' API Win32
Public Const MAX_PATH As Long = 260
Public Const READAPI As Long = 0&       ' ouverture fichier en lecture seule
Public Const READ_WRITE As Long = 2&    ' ouverture fichier en ecriture + lecture
Public Const HFILE_ERROR As Long = -1&
Public Const FILE_BEGIN As Long = 0&
Public Const FILE_CURRENT As Long = 1&
Public Const FILE_END As Long = 2&
Public Const CREATE_ALWAYS = 2&

Public Const VER_PLATFORM_WIN32s = 0
Public Const VER_PLATFORM_WIN32_WINDOWS = 1
Public Const VER_PLATFORM_WIN32_NT = 2

Public Const GENERIC_READ = &H80000000
Public Const GENERIC_WRITE = &H40000000

Public Const FILE_FLAG_RANDOM_ACCESS = &H10000000
Public Const FILE_FLAG_SEQUENTIAL_SCAN = &H8000000
Public Const FILE_FLAG_BACKUP_SEMANTICS = &H2000000
Public Const FILE_SHARE_READ = &H1
Public Const FILE_SHARE_WRITE = &H2
Public Const OPEN_EXISTING = 3
Public Const TRUNCATE_EXISTING = 5
Public Const FILE_ATTRIBUTE_NORMAL = &H80
Public Const INVALID_HANDLE_VALUE& = -1
Public Const HKEY_CURRENT_USER = &H80000001
'Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const SYNCHRONIZE = &H100000
Public Const STANDARD_RIGHTS_ALL = &H1F0000
Public Const READ_CONTROL = &H20000
Public Const STANDARD_RIGHTS_READ = (READ_CONTROL)
Public Const STANDARD_RIGHTS_WRITE = (READ_CONTROL)
Public Const KEY_CREATE_LINK = &H20
Public Const KEY_CREATE_SUB_KEY = &H4
Public Const KEY_ENUMERATE_SUB_KEYS = &H8
Public Const KEY_EVENT = &H1
Public Const KEY_NOTIFY = &H10
Public Const KEY_QUERY_VALUE = &H1
Public Const KEY_SET_VALUE = &H2
Public Const KEYEVENTF_EXTENDEDKEY = &H1
Public Const KEYEVENTF_KEYUP = &H2
Public Const KEY_ALL_ACCESS = _
  ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE _
  Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY _
  Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY _
  Or KEY_CREATE_LINK) And (Not SYNCHRONIZE))
Public Const KEY_READ = ((STANDARD_RIGHTS_READ _
  Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS _
  Or KEY_NOTIFY) And (Not SYNCHRONIZE))
Public Const KEY_WRITE = ((STANDARD_RIGHTS_WRITE _
  Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY) _
  And (Not SYNCHRONIZE))
Public Const KEY_EXECUTE = ((KEY_READ) And (Not SYNCHRONIZE))
Public Const REG_DWORD_LITTLE_ENDIAN = 4
Public Const REG_SZ = 1
Public Const REG_BINARY = 3
Public Const REG_OPTION_NON_VOLATILE = 0
Public Const ERROR_SUCCESS = 0&
Public Const ERROR_FILE_NOT_FOUND = 2&
Public Const ERROR_INVALID_NAME = 123&
Public Const ERROR_NEGATIVE_SEEK = 131&
Public Const ERROR_NO_DATA = 232&
Public Const ERROR_NO_SUCH_MEMBER = 1387&
Public Const ERROR_REGISTRY_CORRUPT = 1015&
Public Const ERROR_SEEK = 25&
Public Const ERROR_MORE_DATA = 234
Public Const ERROR_BADKEY = 1010&
Public Const ERROR_CANTOPEN = 1011&
Public Const ERROR_CANTREAD = 1012&
Public Const ERROR_CANTWRITE = 1013&
Public Const REG_CREATED_NEW_KEY = &H1
Public Const REG_OPENED_EXISTING_KEY = &H2
Public Const REG_GOT_NO_KEY = &H3

Public Const FileUnknown As String = "<<--Unknown-->>"
Public Const CharHexa As String = "0123456789ABCDEF"
Public Const nbTicksDeb As Integer = 1
Public Const nbTicksMouse As Integer = 2
Public Const maxBufSiz As Long = 1048576 ' 1 Moctet taille max des buffers
Public Const RedColor As Long = &HFF&
Public Const LightRed As Long = &HC0E0FF
Public Const Yellow As Long = &HFFFF&
Public Const LightBlue As Long = &HFFFFC0

Public Const randomButtons As Integer = _
  vbYesNoCancel Or vbInformation Or vbExclamation ' (&H73)

' gestion des regions
Public Const RGN_AND As Long = 1
Public Const RGN_COPY As Long = 5
Public Const RGN_DIFF As Long = 4
Public Const RGN_MAX As Long = RGN_COPY
Public Const RGN_MIN As Long = RGN_AND
Public Const RGN_OR As Long = 2
Public Const RGN_XOR As Long = 3


' constantes pour "open", "save"
Public Const OFN_EXPLORER = &H80000
Public Const OFN_ENABLEHOOK = &H20

' constantes definies dans IncludeVC98\WINUSER.H
'#define WM_NOTIFY                       0x004E
Public Const WM_CLOSE = &H10
Public Const WM_NOTIFY = &H4E
Public Const STARTF_USESHOWWINDOW = &H1
Public Const SW_HIDE = 0
Public Const SW_NORMAL = 1
Public Const SW_SHOWMINIMIZED = 2
Public Const SW_INVALIDATE = &H2
Public Const SW_SHOWMAXIMIZED = 3
Public Const SW_MAXIMIZE = 3
Public Const SW_SHOWNOACTIVATE = 4
Public Const SW_ERASE = &H4
Public Const SW_SHOW = 5
Public Const SW_MINIMIZE = 6
Public Const SW_SHOWMINNOACTIVE = 7
Public Const SW_SHOWNA = 8
Public Const SW_RESTORE = 9
Public Const SW_MAX = 10
Public Const SW_SHOWDEFAULT = 10

' constantes definies dans IncludeVC98\COMMDLG.H
' Notifications when Open or Save dialog status changes
'Public Const CDN_FIRST = &HFFFFFDA7
Public Const CDN_INITDONE = &HFFFFFDA7
Public Const CDN_SELCHANGE = &HFFFFFDA6
Public Const CDN_FOLDERCHANGE = &HFFFFFDA5
Public Const CDN_SHAREVIOLATION = &HFFFFFDA4
Public Const CDN_HELP = &HFFFFFDA3
Public Const CDN_FILEOK = &HFFFFFDA2
Public Const CDN_TYPECHANGE = &HFFFFFDA1
Public Const CDN_INCLUDEITEM = &HFFFFFDA0


'**********************************
'**  Type Definitions:

Public Type OSVERSIONINFO
        dwOSVersionInfoSize As Long
        dwMajorVersion As Long
        dwMinorVersion As Long
        dwBuildNumber As Long
        dwPlatformId As Long
        szCSDVersion As String * 128 ' Maintenance string for PSS usage
End Type

Public Type FILETIME
  dwLowDateTime As Long
  dwHighDateTime As Long
End Type

Public Type SYSTEMTIME
        wYear As Integer
        wMonth As Integer
        wDayOfWeek As Integer
        wDay As Integer
        wHour As Integer
        wMinute As Integer
        wSecond As Integer
        wMilliseconds As Integer
End Type

Public Type WIN32_FIND_DATA
        dwFileAttributes As Long
        ftCreationTime As FILETIME
        ftLastAccessTime As FILETIME
        ftLastWriteTime As FILETIME
        nFileSizeHigh As Long
        nFileSizeLow As Long
        dwReserved0 As Long
        dwReserved1 As Long
        cFileName As String * MAX_PATH
        cAlternate As String * 14
End Type


Type SECURITY_ATTRIBUTES
        nLength As Long
        lpSecurityDescriptor As Long
        bInheritHandle As Long
End Type


Type POINTAPI
        x As Long
        y As Long
End Type


Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type


Public Type OPENFILENAME
        lStructSize As Long
        hwndOwner As Long
        hInstance As Long
        lpstrFilter As String
        lpstrCustomFilter As String
        nMaxCustFilter As Long
        nFilterIndex As Long
        lpstrFile As Long
        nMaxFile As Long
        lpstrFileTitle As Long
        nMaxFileTitle As Long
        lpstrInitialDir As String
        lpstrTitle As Long
        flags As Long
        nFileOffset As Integer
        nFileExtension As Integer
        lpstrDefExt As Long
        lCustData As Long
        lpfnHook As Long
        lpTemplateName As String
End Type

Public Type NMHDR
    hwndFrom As Long
    idfrom As Long
    code As Long
End Type

Public Type OFNOTIFY
        hdr As NMHDR
        lpOFN As OPENFILENAME
        pszFile As String        '  May be NULL
End Type


Public Enum FileExitType
  unspecifiedError = -3
  badInitialDirectory
  fileCancelled
  fileOk = 0
End Enum

' ******* Types used for manipulation of BMP files *******



'**  End Type Definitions:
'**********************************

'**********************************
'**  Function Declarations:

Public Declare Function GetLastError Lib "kernel32" () _
  As Long

Public Declare Sub memcpy Lib "kernel32" _
  Alias "RtlMoveMemory" ( _
    ByVal dst As Long, _
    ByVal src As Long, _
    ByVal cnt As Long)

Public Declare Function GetVersionEx Lib "kernel32" _
    Alias "GetVersionExA" _
    (lpVersionInformation As OSVERSIONINFO) As Long

' prendre garde a l'ordre des parametres (inverse des precedents)
Public Declare Function GetTempPath Lib "kernel32" _
  Alias "GetTempPathA" (ByVal nBufferLength As Long, _
  ByVal lpBuffer As String) As Long

Public Declare Function GetTempFileName Lib "kernel32" _
  Alias "GetTempFileNameA" (ByVal lpszPath As String, _
  ByVal lpPrefixString As String, ByVal wUnique As Long, _
  ByVal lpTempFileName As String) As Long

Public Declare Function GetCurrentDirectory Lib "kernel32" _
  (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long

Public Declare Function SetEndOfFile& Lib "kernel32" _
  (ByVal hFile As Long)

Public Declare Function lopen& Lib "kernel32" Alias "_lopen" _
  (ByVal lpPathName As String, ByVal iReadWrite As Long)

Public Declare Function lclose& Lib "kernel32" Alias "_lclose" _
  (ByVal hFile As Long)

Public Declare Function CreateFile Lib "kernel32" _
  Alias "CreateFileA" ( _
  ByVal lpFileName As String, _
  ByVal dwDesiredAccess As Long, _
  ByVal dwShareMode As Long, _
  ByRef lpSecurityAttributes As SECURITY_ATTRIBUTES, _
  ByVal dwCreationDisposition As Long, _
  ByVal dwFlagsAndAttributes As Long, _
  ByVal hTemplateFile As Long) As Long

Public Declare Function CloseHandle Lib "kernel32" _
  (ByVal hObject As Long) As Long

Public Declare Function GetFileSize Lib "kernel32" _
  (ByVal hFile As Long, lpFileSizeHigh As Long) As Long

Public Declare Function GetFileTime& Lib "kernel32" _
  (ByVal hFile As Long, lpCreationTime As FILETIME, _
  lpLastAccessTime As FILETIME, lpLastWriteTime As FILETIME)

Public Declare Function SetFileTime& Lib "kernel32" _
  (ByVal hFile As Long, lpCreationTime As FILETIME, _
  lpLastAccessTime As FILETIME, lpLastWriteTime As FILETIME)

Public Declare Function SetFilePointer Lib "kernel32" _
  (ByVal hFile As Long, ByVal lDistanceToMove As Long, _
  lpDistanceToMoveHigh As Long, ByVal dwMoveMethod As Long) _
  As Long
Public Declare Sub GetLocalTime Lib "kernel32" _
  (lpSystemTime As SYSTEMTIME)

Public Declare Function FileTimeToLocalFileTime& Lib "kernel32" _
  (lpFileTime As FILETIME, lpLocalFileTime As FILETIME)

Public Declare Function LocalFileTimeToFileTime& Lib "kernel32" _
  (lpLocalFileTime As FILETIME, lpFileTime As FILETIME)

Public Declare Function FileTimeToSystemTime Lib "kernel32" _
  (lpFileTime As FILETIME, lpSystemTime As SYSTEMTIME) As Long

Public Declare Function SystemTimeToFileTime Lib "kernel32" _
  (lpSystemTime As SYSTEMTIME, lpFileTime As FILETIME) As Long

Public Declare Function DosDateTimeToFileTime& Lib "kernel32" _
  (ByVal wFatDate As Long, ByVal wFatTime As Long, _
  lpFileTime As FILETIME)

Public Declare Function FileTimeToDosDateTime& Lib "kernel32" _
  (lpFileTime As FILETIME, lpFatDate As Integer, _
  lpFatTime As Integer)

Public Declare Function RegCreateKey Lib "advapi32.dll" _
  Alias "RegCreateKeyA" (ByVal hKey As Long, _
  ByVal lpSubKey As String, _
  phkResult As Long) As Long

Public Declare Function RegCreateKeyEx Lib "advapi32.dll" _
  Alias "RegCreateKeyExA" (ByVal hKey As Long, _
  ByVal lpSubKey As String, ByVal Reserved As Long, _
  ByVal lpClass As String, ByVal dwOptions As Long, _
  ByVal samDesired As Long, _
  lpSecurityAttributes As Variant, _
  phkResult As Long, lpdwDisposition As Long) As Long

Public Declare Function RegOpenKey Lib "advapi32.dll" _
  Alias "RegOpenKeyA" (ByVal hKey As Long, _
  ByVal lpSubKey As String, phkResult As Long) As Long

Public Declare Function RegOpenKeyEx Lib "advapi32.dll" _
  Alias "RegOpenKeyExA" (ByVal hKey As Long, _
  ByVal lpSubKey As String, ByVal ulOptions As Long, _
  ByVal samDesired As Long, _
  phkResult As Long) As Long

Public Declare Function RegCloseKey Lib "advapi32.dll" _
  (ByVal hKey As Long) As Long

Public Declare Function RegQueryValue Lib "advapi32.dll" _
  Alias "RegQueryValueA" ( _
    ByVal hKey As Long, _
    ByVal lpSubKey As String, _
    ByVal lpValue As String, _
    lpcbValue As Long) As Long

Public Declare Function RegQueryValueEx Lib "advapi32.dll" _
  Alias "RegQueryValueExA" (ByVal hKey As Long, _
  ByVal lpValueName As String, ByVal lpReserved As Long, _
  lpType As Long, lpData As Any, lpcbData As Long) As Long

Public Declare Function RegSetValue Lib "advapi32.dll" _
  Alias "RegSetValueA" ( _
    ByVal hKey As Long, _
    ByVal lpSubKey As String, _
    ByVal dwType As Long, _
    ByVal lpData As String, _
    ByVal cbData As Long) As Long

Public Declare Function RegSetValueEx Lib "advapi32.dll" _
  Alias "RegSetValueExA" (ByVal hKey As Long, _
  ByVal lpValueName As String, ByVal Reserved As Long, _
  ByVal dwType As Long, lpData As Any, _
  ByVal cbData As Long) As Long

Public Declare Function RegDeleteKey Lib "advapi32.dll" _
  Alias "RegDeleteKeyA" (ByVal hKey As Long, _
  ByVal lpSubKey As String) As Long

Public Declare Function GetParent Lib "user32" _
  (ByVal hwnd As Long) As Long

Public Declare Function GetClientRect Lib "user32" _
  (ByVal hwnd As Long, lpRect As RECT) As Long

Public Declare Function GetWindowRect Lib "user32" _
  (ByVal hwnd As Long, lpRect As RECT) As Long

Public Declare Function GetCursorPos Lib "user32" _
  (lpPoint As POINTAPI) As Long ' in SCREEN coordinates (pixels)

Public Declare Function GetCaretPos Lib "user32" _
  (lpPoint As POINTAPI) As Long ' in CLIENT coordinates (pixels)
Public Declare Function ShowCaret Lib "user32" _
  (ByVal hwnd As Long) As Long

Public Declare Function ScreenToClient Lib "user32" _
  (ByVal hwnd As Long, lpPoint As POINTAPI) As Long

Public Declare Function ClientToScreen Lib "user32" _
  (ByVal hwnd As Long, lpPoint As POINTAPI) As Long

Public Declare Function MoveWindow Lib "user32" _
  (ByVal hwnd As Long, _
  ByVal x As Long, ByVal y As Long, _
  ByVal nWidth As Long, ByVal nHeight As Long, _
  ByVal bRepaint As Long) As Long

Public Declare Function SendMessage _
  Lib "user32" Alias "SendMessageA" _
  (ByVal hwnd As Long, ByVal wMsg As Long, _
  ByVal wParam As Long, ByVal lParam As Long) As Long

Public Declare Function GetOpenFileName Lib "comdlg32.dll" _
  Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long

Public Declare Function GetSaveFileName Lib "comdlg32.dll" _
  Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long

Public Declare Function GetFullPathName Lib "kernel32" _
  Alias "GetFullPathNameA" (ByVal lpFileName As String, _
  ByVal nBufferLength As Long, ByVal lpBuffer As String, _
  ByVal lpFilePart As String) As Long

Public Declare Function FindFirstFile Lib "kernel32" _
  Alias "FindFirstFileA" (ByVal lpFileName As String, _
  lpFindFileData As WIN32_FIND_DATA) As Long

Public Declare Function FindClose Lib "kernel32" _
  (ByVal hFindFile As Long) As Long

Public Declare Function GetActiveWindow Lib "user32" () As Long

' eviter de faire doevents s'il n'y a rien pour nous
Public Declare Function GetInputState Lib "user32" () As Long

' Gestion de l'affichage
Public Declare Function InvalidateRect Lib "user32" _
  (ByVal hwnd As Long, ByVal lpRect As Long, ByVal bErase As Long) As Long

'gestion des regions
Public Declare Function CreateRectRgn Lib "gdi32" _
  (ByVal X1 As Long, ByVal Y1 As Long, _
  ByVal X2 As Long, ByVal Y2 As Long) As Long
Public Declare Function CreateEllipticRgn Lib "gdi32" _
  (ByVal X1 As Long, ByVal Y1 As Long, _
  ByVal X2 As Long, ByVal Y2 As Long) As Long
Public Declare Function CreatePolygonRgn Lib "gdi32" _
  (lpPoint As POINTAPI, ByVal nCount As Long, _
  ByVal nPolyFillMode As Long) As Long
Public Declare Function CreatePolyPolygonRgn Lib "gdi32" _
  (lpPoint As POINTAPI, lpPolyCounts As Long, _
  ByVal nCount As Long, ByVal nPolyFillMode As Long) As Long
Public Declare Function CombineRgn Lib "gdi32" _
  (ByVal hDestRgn As Long, _
  ByVal hSrcRgn1 As Long, ByVal hSrcRgn2 As Long, _
  ByVal nCombineMode As Long) As Long
Public Declare Function SetWindowRgn Lib "user32" _
  (ByVal hwnd As Long, ByVal hRgn As Long, _
  ByVal bRedraw As Boolean) As Long
Public Declare Function DeleteObject Lib "gdi32" _
  (ByVal hObject As Long) As Long

' recherche de l'executable pour ouvrir un fichier
Public Declare Function FindExecutable Lib "shell32.dll" Alias "FindExecutableA" _
  (ByVal lpFile As String, ByVal lpDirectory As String, _
  ByVal lpResult As String) As Long

' Lancement d'un processus, en pouvant recuperer des infos pour attendre sa fin
Public Declare Function CreateProcess Lib "kernel32" Alias "CreateProcessA" _
  (ByVal lpApplicationName As String, ByVal lpCommandLine As String, _
  lpProcessAttributes As SECURITY_ATTRIBUTES, _
  lpThreadAttributes As SECURITY_ATTRIBUTES, _
  ByVal bInheritHandles As Long, _
  ByVal dwCreationFlags As Long, _
  lpEnvironment As Any, _
  ByVal lpCurrentDirectory As String, _
  lpStartupInfo As STARTUPINFO, _
  lpProcessInformation As PROCESS_INFORMATION) As Long

Public Declare Function WaitForInputIdle Lib "user32" _
  (ByVal hProcess As Long, ByVal dwMilliseconds As Long) As Long
Public Declare Function WaitForSingleObject Lib "kernel32" _
  (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long

'Public Declare Function TerminateProcess Lib "kernel32" _
'  (ByVal hProcess As Long, ByVal uExitCode As Long) As Long
Public Declare Function EnumThreadWindows Lib "user32" _
  (ByVal dwThreadId As Long, _
  ByVal lpfn As Long, _
  ByVal lParam As Long) As Long

'Public Declare Function EnumWindows Lib "user32" _
'  (ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long

'Public Declare Function EnumChildWindows Lib "user32" _
'  (ByVal hWndParent As Long, _
'  ByVal lpEnumFunc As Long, _
'  ByVal lParam As Long) As Long


'Public Declare Function GetWindowThreadProcessId Lib "user32" _
'  (ByVal hWnd As Long, lpdwProcessId As Long) As Long


Public Const INFINITE = &HFFFF      '  Infinite timeout
Public Const WAIT_TIMEOUT = &H102   '  258

Public Type STARTUPINFO
        cb As Long
        lpReserved As String
        lpDesktop As String
        lpTitle As String
        dwX As Long
        dwY As Long
        dwXSize As Long
        dwYSize As Long
        dwXCountChars As Long
        dwYCountChars As Long
        dwFillAttribute As Long
        dwFlags As Long
        wShowWindow As Integer
        cbReserved2 As Integer
        lpReserved2 As Long
        hStdInput As Long
        hStdOutput As Long
        hStdError As Long
End Type

Public Type PROCESS_INFORMATION
        hProcess As Long
        hThread As Long
        dwProcessId As Long
        dwThreadId As Long
End Type

Public Const NORMAL_PRIORITY_CLASS = &H20


' acces au registry
Public keyhandle As Long

Public Sub CloseRegistry()
On Error Resume Next
'Debug.Print "CloseRegistry"
If keyhandle = -1 Then Exit Sub ' si keyhandle = -1 rien  faire
If keyhandle <> 0 Then ' si keyhandle = 0 on n'a pas encore touche au registry
  Call RegCloseKey(keyhandle)
End If
keyhandle = -1
End Sub

' initialisation du registry - revient a une fermeture
Public Sub InitRegistry()
'Debug.Print "InitRegistry"
CloseRegistry
End Sub

' ouverture du registry
Public Function OpenRegistry() As Boolean
  Dim RegRes As Long
On Error Resume Next
'Debug.Print "OpenRegistry"
If keyhandle = -1 Then
  RegRes = RegOpenKey( _
    HKEY_CURRENT_USER, _
    "Software\41394021400013\" & ProgNum & "\Settings", _
    keyhandle)
  If RegRes = ERROR_SUCCESS Then
' keyhandle a ete positionne par RegOpenKey
    OpenRegistry = True
  Else
    keyhandle = -1
    Err.Number = RegRes
    If RegRes = ERROR_FILE_NOT_FOUND Then
      MsgBox "Critical problem while opening registry (errno=" & _
        Err.Number & ") " & vbCr & _
        Err.Description, vbOKOnly + vbExclamation, "OpenRegistry"
    End If
    OpenRegistry = False
  End If
Else
' deja ouvert - fermer et rouvrir
  CloseRegistry
  OpenRegistry = OpenRegistry() ' on se rappelle recursivement
End If
End Function

Public Function CreateKey() As Long
  Dim RegRes As Long
On Error Resume Next
'Debug.Print "CreateKey"
If keyhandle = -1 Then
  RegRes = RegCreateKey( _
    HKEY_CURRENT_USER, _
    "Software\41394021400013\" & ProgNum & "\Settings", _
    keyhandle)
  If RegRes = ERROR_SUCCESS Then
' keyhandle a ete positionne par RegOpenKey
    CreateKey = REG_CREATED_NEW_KEY
  Else
    keyhandle = -1
    Err.Number = RegRes
    CreateKey = REG_GOT_NO_KEY
  End If
Else
  CloseRegistry ' au cas ou ce serait ouvert avec une autre clef
  CreateKey = CreateKey() ' se rappeler avec keyhandle = -1
End If
End Function

' ouvrir le registry et creer si pas trouve
' indique en sortie si la clef a ete creee ou ouverte
Public Function OpenOrCreateRegistry() As Long
  Dim RegRes As Long
On Error Resume Next
'Debug.Print "OpenOrCreateRegistry"
If keyhandle = -1 Then
  If OpenRegistry Then
    OpenOrCreateRegistry = REG_OPENED_EXISTING_KEY
  Else
' essayer de le creer et rendre REG_CREATED_NEW_KEY ou REG_GOT_NO_KEY
    OpenOrCreateRegistry = CreateKey()
  End If
Else
' fermer ouverture precedente
  CloseRegistry
  OpenOrCreateRegistry = OpenOrCreateRegistry()
End If
End Function



'
' lecture entree dans registry(subKey)
' rend resultat sous forme de chaine, avec Err.Number =
' ERROR_SUCCESS si pas de pbe (la valeur a ete lue - on peut qd meme avoir s="")
' ERROR_CANTREAD (et s="") si lecture impossible bien que la clef existe
' ERROR_NO_SUCH_MEMBER (et s="") si subkey n'existe pas mais que la key existe
' ou si ni subkey ni sa key n'existaient et qu'on a pu creer key
' ERROR_CANTOPEN et s="") si ni subkey ni sa key n'existaient,
'   et on n'a pas pu creer key
' ERROR_REGISTRY_CORRUPT si erreur bizarre
'
Public Function GetRegistry(subKey As String) As String
Dim RegRes As Long, RegDisp As Long, s As String, lg As Long
On Error Resume Next
'Debug.Print "GetRegistry"

'If keyhandle = -1 Then
RegDisp = OpenOrCreateRegistry()
'End If

Select Case RegDisp
  Case REG_OPENED_EXISTING_KEY
    lg = 0 ' juste pour connatre la vraie lgr ncessaire
    s = ""
    RegRes = RegQueryValue(keyhandle, subKey, s, lg)
    If RegRes = ERROR_SUCCESS Then
' la valeur stocke est "" (ca peut arriver !)
      Err.Number = ERROR_SUCCESS
      GetRegistry = ""
    ElseIf RegRes = ERROR_MORE_DATA Then ' on doit avoir un buffer trop court
      s = Space(lg) ' allouer ce qu'il faut
      RegRes = RegQueryValue(keyhandle, subKey, s, lg)
      If RegRes = ERROR_SUCCESS Then
        Err.Number = ERROR_SUCCESS
        GetRegistry = stripNullChars(s) ' il peut y avoir un '\0' a la fin...
      Else ' erreur bizarre - on avait pu lire une fois
        Err.Number = ERROR_CANTREAD
        GetRegistry = ""
      End If
    ElseIf RegRes = ERROR_FILE_NOT_FOUND Then
      Err.Number = ERROR_NO_SUCH_MEMBER
      GetRegistry = ""
    Else
      Err.Number = ERROR_REGISTRY_CORRUPT
      GetRegistry = ""
    End If

  Case REG_CREATED_NEW_KEY
' on a cree key, donc subKey n'existe pas
    Err.Number = ERROR_NO_SUCH_MEMBER
    GetRegistry = ""

  Case Else ' REG_GOT_NO_KEY
    Err.Number = ERROR_CANTOPEN
    GetRegistry = ""
End Select

End Function



' ecriture entree dans registry(subKey)
' rend resultat sous forme de code d'erreur, valant :
' ERROR_SUCCESS si pas de pbe (la valeur a ete ecrite)
' ERROR_CANTOPEN si ni subkey ni sa key n'existaient,
'   et on n'a pas pu creer key
' les autres valeurs rendues par RegSetValue sinon
'
Public Function SetRegistry(subKey As String, Value As String) As Long
Dim RegRes As Long, s As String, RegDisp As Long
On Error Resume Next
'Debug.Print "SetRegistry"

'If keyhandle = -1 Then
RegDisp = OpenOrCreateRegistry()
'End If

Select Case RegDisp
  Case REG_OPENED_EXISTING_KEY, REG_CREATED_NEW_KEY
    s = Value & Chr(0)
    SetRegistry = RegSetValue(keyhandle, subKey, REG_SZ, s, Len(s) - 1)

  Case Else ' REG_GOT_NO_KEY
    SetRegistry = Err.Number
End Select

End Function


' lecture valeur ou ecriture de valeur par defaut dans le registry
Public Function ReadOrSetDefaultReg(subKey As String, _
    variable As String, defValue As String) As Long

Dim RegRes As Long, s As String, lg As Long
On Error Resume Next

s = GetRegistry(subKey)
Select Case Err.Number
  Case ERROR_SUCCESS
    variable = s
    ReadOrSetDefaultReg = ERROR_SUCCESS

  Case ERROR_NO_SUCH_MEMBER 'il faut creer la subKey (la key existe)
' et donner a la vairiable la valeur par defaut
    variable = defValue
    s = CStr(variable)
    ReadOrSetDefaultReg = SetRegistry(subKey, s)

  Case Else ' les autres erreurs sont redhibitoires - on dit OK qd meme
    variable = defValue
    ReadOrSetDefaultReg = ERROR_SUCCESS
End Select
End Function




'
' Lancement d'un processus, en pouvant recuperer des infos pour attendre sa fin
' on utilise la fonction
' Public Declare Function CreateProcess Lib "kernel32" Alias "CreateProcessA" _
  (ByVal lpApplicationName As String, _
  ByVal lpCommandLine As String, _
  lpProcessAttributes As SECURITY_ATTRIBUTES, _
  lpThreadAttributes As SECURITY_ATTRIBUTES, _
  ByVal bInheritHandles As Long, _
  ByVal dwCreationFlags As Long, _
  lpEnvironment As Any, _
  ByVal lpCurrentDirectory As String, _
  lpStartupInfo As STARTUPINFO, _
  lpProcessInformation As PROCESS_INFORMATION) As Long
' On utilise aussi la fonction
' Public Declare Sub ZeroMemory Lib "KERNEL32" Alias "RtlMoveMemory" _
  (dest As Any, ByVal numBytes As Long)
' La fonction rend un boolean permettant d'attendre
' la fin du process
Public Function LaunchProcess( _
  sCmdLine As String, _
  ByRef processInf As PROCESS_INFORMATION, _
  ByVal boHideWindow As Boolean) _
  As Boolean
Dim lpSecAttr As SECURITY_ATTRIBUTES
Dim startUpInf As STARTUPINFO
Dim lResulCreProc As Long, ptr As Long

With startUpInf
  .cb = LenB(startUpInf)
  .lpReserved = vbNullString
  .lpDesktop = vbNullString
  .dwFlags = STARTF_USESHOWWINDOW
  If boHideWindow Then
    .wShowWindow = SW_HIDE
  Else
    .wShowWindow = SW_NORMAL
  End If
End With

With lpSecAttr
  .nLength = LenB(lpSecAttr) ' 12
  .lpSecurityDescriptor = 0&
  .bInheritHandle = False
End With

lResulCreProc = CreateProcess( _
  vbNullString, _
  sCmdLine, _
  lpSecAttr, _
  lpSecAttr, _
  True, _
  NORMAL_PRIORITY_CLASS, _
  ByVal 0&, _
  vbNullString, _
  startUpInf, _
  processInf)
LaunchProcess = (lResulCreProc <> 0)
End Function

'
' Attente de la terminaison d'un processus lance par CreateProcess
' La variable boVarToScanForCancel est une variable externe
' qui force a sortir de la boucle
Public Sub WaitForProcessToTerminate( _
  ByRef processInf As PROCESS_INFORMATION, _
  ByRef boVarToScanForCancel As Boolean)
Dim lRes As Long

' Attendre la fin d'initialisation du prcessus
Call WaitForInputIdle(processInf.hProcess, INFINITE)
' On n'a plus besoin du handle du thread
Call CloseHandle(processInf.hThread)
Do
  lRes = WaitForSingleObject(processInf.hProcess, 0)
  If (lRes <> WAIT_TIMEOUT) Then
    Exit Do
  End If
  DoEvents
  If boVarToScanForCancel Then
'    Call TerminateProcess(processInf.hProcess, 0)
    Call CloseWindowsFromThread(processInf.dwThreadId) 'et non processInf.hThread !!!
    Exit Do
  End If
Loop While True
Call CloseHandle(processInf.hProcess)
End Sub


Public Sub CloseWindowsFromThread(ByVal lThreadID As Long)
Call EnumThreadWindows(lThreadID, AddressOf EnumWinProc, 0)
'Call EnumThreadWindows(lThreadID, AddressOf EnumWinProc, lThreadID)
End Sub


Public Function EnumWinProc(ByVal hwnd As Long, ByVal lParam As Long) As Long
Dim lWndProcID As Long, lWndThreadID As Long

On Error GoTo ERRORENUMANDCLOSE ' indispensable dans une callback !
'lWndThreadID = GetWindowThreadProcessId(hWnd, lWndProcID)
'If ((lWndProcID = lParam) Or (lWndThreadID = lParam)) Then
  Call SendMessage(hwnd, WM_CLOSE, 0, 0)
'End If
EnumWinProc = 1 ' rendre 1 pour continuer
Exit Function

ERRORENUMANDCLOSE:
  EnumWinProc = 0 ' rendre 0 pour arreter
End Function
